var MSTATE_OFFLINE = 1;
var MSTATE_ONLINE = 2;
var MSTATE_BUSY = 10;
var MSTATE_BE_RIGHT_BACK = 14;
var MSTATE_IDLE = 18;
var MSTATE_AWAY = 34;
var MSTATE_IN_A_CALL = 50;
var MSTATE_OUT_TO_LUNCH = 66;
var MSTATE_APPEAR_OFFLINE = 6;
var MSTATE_FINDING_SERVER = 256;
var MSTATE_CONNECTING_SERVER = 512;
var MSTATE_SYNCHRONIZING_SERVER = 768;
var MSTATE_DISCONNECTING_SERVER = 1024;

var currContact = "";

function body_onLoad()
{
	//var users = msgr.MyFriendlyName;
	//alert(users);
	if (Messenger.MyStatus != 1 && Messenger.MyStatus < 100)
	{
		//alert(Messenger.UnreadEmailCount(0));
		//emailDiv = document.getElementById("email");
		//emailDiv.onmouseover = onMouseOverEmail;
		//
		//
		//emailImage = document.createElement("img");
		//emailImage.id = "email_IMG";

		//emailImage.src = "Image/mail.png";
		//emailImage.style.verticalAlign = "middle";
		//emailDiv.appendChild(emailImage);
		//emailCount = document.createTextNode("(" + Messenger.UnreadEmailCount(0) + ")");
		//emailDiv.appendChild(emailCount);
		email_img.onmouseover = onMouseOverEmail;
		email_img.onmouseout = onMouseOutEmail;
		email_img.onclick = onMouseClickEmail;
		email.innerHTML = "(" + Messenger.UnreadEmailCount(0) + ")";
		document.getElementById("selectMyStatus").selectedIndex = getSelectNum(Messenger.MyStatus)
		document.getElementById("myStatus_IMG").src = "Image/" + getContactStatus(Messenger.MyStatus) + ".png";
		document.getElementById("test").innerHTML = "";
		myName.innerHTML = Messenger.MyFriendlyName;
		signinName.style.display = "none";
		for (var i=0; i<Messenger.MyContacts.Count; i++)
		{
			if (Messenger.MyContacts.Item(i).Status != 1 && Messenger.MyContacts.Item(i).Status != 0)
			{
				//document.getElementById("selectMyStatus").selectedIndex = getSelectNum(Messenger.MyStatus)
				contactDiv = document.createElement("div");
				contactDiv.id = Messenger.MyContacts.Item(i).SigninName;
				contactDiv.Contact = Messenger.MyContacts.Item(i).SigninName;
				contactDiv.Num = Messenger.MyContacts.Item(i);
				//contactDiv.group = Messenger.MyContacts.Item(i).group;	
				contactDiv.className = "contact";
				contactDiv.onmouseover = onMouseOverContact;
				contactDiv.onmouseout = onMouseOutContact;
				contactDiv.ondblclick = onDoubleClickContact;
				contactDiv.onclick = onMouseClick;
				contactImage = document.createElement("img");
				contactImage.id = Messenger.MyContacts.Item(i).SigninName + "_IMG";

				contactImage.src = "Image/" + getContactStatus(Messenger.MyContacts.Item(i).Status) + ".png";
				contactImage.style.verticalAlign = "middle";
				contactDiv.appendChild(contactImage);

				contactDiv.appendChild(document.createTextNode(Messenger.MyContacts.Item(i).FriendlyName))
				document.getElementById("test").appendChild(contactDiv);
			}
		}
		//test.style.display = "block";
	}
	else if (Messenger.MyStatus == MSTATE_OFFLINE)
	{
		signinName.style.display = "block";
	}
}

function sortContactByGroup()
{
	for (var i=0; i<Messenger.Mygroups.Count; i++)
	{
		groupDIV = document.createElement("div");
		groupDIV.id = Messenger.Mygroups.Item(i).Name;
		groupDIV.className = "group";
		//groupDIV.onclick = onClickGroup;
		groupDIV.appendChild(document.createTextNode(Messenger.MyGroups.Item(i).Name + " (" + getGroupOnlineNum(i) + ")"));
		for (var j=0; j<Messenger.MyGroups.Item(i).Contacts.Count; j++)
		{
			if (Messenger.MyGroups.Item(i).Contacts.Item(j).Status != 1)
			{
				contactDIV = document.createElement("div");
				contactDIV.id = Messenger.MyGroups.Item(i).Contacts.Item(j).SigninName;
				contactDIV.Contact = Messenger.MyGroups.Item(i).Contacts.Item(j).SigninName;
				//contactDIV.group = Messenger.MyContacts.Item(i).group;	
				contactDIV.className = "contact";
				contactDIV.onmouseover = onMouseOverContact;
				contactDIV.onmouseout = onMouseOutContact;
				contactDIV.ondblclick = onDoubleClickContact;
				contactDiv.onclick = onMouseClick;
				contactImage = document.createElement("img");
				contactImage.id = Messenger.MyGroups.Item(i).Contacts.Item(j).SigninName + "_IMG";

				contactImage.src = "Image/" + getContactStatus(Messenger.MyGroups.Item(i).Contacts.Item(j).Status) + ".png";
				contactImage.style.verticalAlign = "middle";
				contactDIV.appendChild(contactImage);

				contactDIV.appendChild(document.createTextNode(Messenger.MyGroups.Item(i).Contacts.Item(j).FriendlyName));
				groupDIV.appendChild(contactDIV)
			}
		}
		document.getElementById("test").appendChild(groupDIV);
	}
}

function getGroupOnlineNum(group)
{
	var j=0;
	for (i=0; i<Messenger.MyGroups.Item(group).Contacts.Count; i++)
	{
		if (Messenger.MyGroups.Item(group).Contacts.Item(i).Status != 1)
		{
			j++;
		}
	}
	return j;
}

function getContactStatus(status)
{
	switch(status)
	{
		case 2:
			return "Online";
		case 10:
			return "Busy";
		case 14:
			return "Be right back";
		case 18:
			return "Away";
		case 34:
			return "Away";
		case 50:
			return "In a call";
		case 66:
			return "Out to lunch";
		case 6:
			return "Invisible";
		case 1:
			return "Offline";
		case 0:
			return "Offline";
			//return "Unknown";
		case 256:
			return "Offline";
			//return "Finding Server";
		case 512:
			return "Offline";
			//return "Connecting to server";
		case 768:
			return "Offline";
			//return "Synchronizing with server";
		case 1024:
			return "Offline";//return "Disconnecting from server";
		default:
			return "Offline";//return "error";
	}
}

function getSelectNum(status)
{
	switch(status)
	{
		case 2:
			return 0;
		case 10:
			return 1;
		case 14:
			return 2;
		case 18:
			return 3;
		case 34:
			return 3;
		case 50:
			return 4;
		case 66:
			return 5;
		case 6:
			return 6;
		case 1:
			return 7;
		case 0:
			return "Unknown";
		case 256:
			return "Finding Server";
		case 512:
			return "Connecting to server";
		case 768:
			return "Synchronizing with server";
		case 1024:
			return "Disconnecting from server";
		default:
			return "error";
	}
}

function changeStatus(status)
{
	if (Messenger.MyStatus != 1)
	{
		if (status.value == 1)
		{
			//Messenger.MyStatus = status.value;
			//test.style.display = "none";
			if (Messenger.MyStatus != 1)
			{
				Messenger.Signout();
			}
		}
		else
		{
			Messenger.MyStatus = status.value;
		}
	}
}

function onMouseOverEmail()
{
	this.style.backgroundImage = "url('Image/cbg.png')";
}

function onMouseOutEmail()
{
	this.style.backgroundImage = "";
}

function onMouseClickEmail()
{
	Messenger.OpenInbox();
}

function onMouseOverContact()
{
	this.style.backgroundImage = "url('Image/cbg.png')";
	this.style.color = "white";
	this.style.cursor = "default";
	//System.Gadget.Flyout.file = "test.html";
	//System.Gadget.Flyout.show=true;
	
	contactTooltip.style.left = 1;
	//contactTooltip.style.top = window.event.clientY+12;
	contactTooltip.innerHTML = "";
	contactTooltip.style.filter = "progid:DXImageTransform.Microsoft.Gradient(startColorStr='#FFFFFF', endColorStr='#E8F3FF', gradientType='0')";
	//contactTooltip.appendChild(document.createTextNode(Messenger.MyContacts.Item(this).FriendlyName + " (" + getStatusTextFromConstant(Messenger.MyContacts.Item(this).Status) + ")<" + Messenger.MyContacts.Item(this).id + ">"));
	contactTooltip.appendChild(document.createTextNode(this.Num.FriendlyName + " (" + getContactStatus(this.Num.Status) + ") <" + this.Num.SigninName + ">"));
	
	//
	//{
	
//	}	

	contactTooltip.style.display = "block";
	//alert(this.offsetTop);
	var top = (Math.floor((window.event.clientY-59)/15) * 15) + 60;
	if (contactTooltip.offsetHeight > (200-top-20))
	{
		contactTooltip.style.top = top-contactTooltip.offsetHeight-10;
	}
	else
	{
		contactTooltip.style.top = top+20;
	}
	//tooltipTimer = setTimeout('showTooltip();',1000);
}

function onMouseClick()
{
	if (System.Gadget.Flyout.show == true && currContact == this.Contact)
	{
		System.Gadget.Flyout.show=false;
	}
	else
	{
		System.Gadget.Flyout.file = "test.html";
		System.Gadget.Flyout.show=true;
		currContact = this.Contact;
	}
}
function onMouseOutContact()
{
	this.style.backgroundImage="";
	this.style.color = "black";
	this.style.cursor = "";
	contactTooltip.style.display = "none";
	//System.Gadget.Flyout.show=false;
}

function onDoubleClickContact()
{
	var contact = this.Contact;
	Messenger.InstantMessage(this.Contact);
	
}

function signin()
{
	try
	{
		messenger.AutoSignin();
	}
	catch (err)
	{
		
	}
}

function Messenger::OnMyStatusChange(hr, mMyStatus)
{
	//document.getElementById("myName").innerHTML = Messenger.MyFriendlyName;
	
	document.getElementById("selectMyStatus").selectedIndex = getSelectNum(Messenger.MyStatus)
	document.getElementById("myStatus_IMG").src = "Image/" + getContactStatus(Messenger.MyStatus) + ".png";
}

function Messenger::OnSignin()
{
	//test.innerHTML = "";
	//test.style.display = "none";
	//document.getElementById("myName").innerHTML = Messenger.MyFriendlyName;
	//document.getElementById("selectMyStatus").selectedIndex = getSelectNum(Messenger.MyStatus)
	//document.getElementById("myStatus_IMG").src = "Image/" + getContactStatus(Messenger.MyStatus) + ".png";
	//location.href = 'gadget.html'
	body_onLoad();
}

function Messenger::OnSignout()
{
	//test.style.display = "none";
	test.innerHTML = "";
	body_onLoad();
	//location.href = "gadget.html";
	//contactTooltip.style.display = "none";
	//document.getElementById("selectMyStatus").selectedIndex = 7
	//document.getElementById("myStatus_IMG").src = "Image/offline.png";
}

function Messenger::OnContactStatusChange(pMContact, mStatus)
{   
	if (pMContact.Status == 1)
	{
	   var contactDivToMove = document.getElementById(pMContact.SigninName);
	   if (contactDivToMove != null)
	   {
		   contactDivToMove.style.display = "none";
	   }
	}
	else if (pMContact.Status < 100 && pMContact.Status != 0)
	{
		var img = document.getElementById(pMContact.SigninName + "_IMG");
		if (img != null)
		{
			img.src = "Image/" + getContactStatus(pMContact.Status) + ".png";
		}
		var contactDiv = document.getElementById(pMContact.SigninName);
		if (contactDiv != null)
		{
	   		contactDiv.style.display = "block";
		}
		else
		{
			contactDiv = document.createElement("div");
			contactDiv.id = pMContact.SigninName;
			contactDiv.Contact = pMContact.SigninName;
			contactDiv.Num = pMContact;
			//contactDiv.group = pMContact.group;	
			contactDiv.className = "contact";
			contactDiv.onmouseover = onMouseOverContact;
			contactDiv.onmouseout = onMouseOutContact;
			contactDiv.ondblclick = onDoubleClickContact;
			contactDiv.onclick = onMouseClick;
			contactImage = document.createElement("img");
			contactImage.id = pMContact.SigninName + "_IMG";

			contactImage.src = "Image/" + getContactStatus(pMContact.Status) + ".png";
			contactImage.style.verticalAlign = "middle";
			contactDiv.appendChild(contactImage);

			contactDiv.appendChild(document.createTextNode(pMContact.FriendlyName))
			document.getElementById("test").appendChild(contactDiv);
		}
		//document.getElementById(pMContact.SigninName + "_IMG").src = "Image/" + getContactStatus(pMContact.Status) + ".png";
	}
}

function Messenger::OnContactFriendlyNameChange(hr, pMContact, bstrPrevFriendlyName)
{
	if (pMContact.Status != 1)
	{
		var contactDiv = pMContact.SigninName;
		if (contactDiv != null)
		{
			contactDiv.innerHTML = "";
			contactImage = document.createElement("img");
			contactImage.id = pMContact.SigninName + "_IMG";

			contactImage.src = "Image/" + getContactStatus(pMContact.Status) + ".png";
			contactImage.style.verticalAlign = "middle";
			contactDiv.appendChild(contactImage);

			contactDiv.appendChild(document.createTextNode(pMContact.FriendlyName))
		}
	}
}


function Messenger::OnUnreadEmailChange(mFolder, cUnreadEmail, pBoolfEnableDefault)
{
	if (mFolder == 0)
	{
		email.innerHTML = "(" + cUnreadEmail + ")";
	}
}